<template lang="pug">
.full-width(style="box-sizing: border-box")
  q-dialog(v-model="showAssignmentVsActual")
    BreakoutRooms(
      :currentBreakoutRoomAssignment="currentBreakoutRoomAssignment",
      :currentBreakoutRooms="currentBreakoutRooms",
      :renameRoom="handleRenameRoom",
      :firebase="firebase",
      :meetingId="this.context.meetingid"
    )
  q-dialog(v-model="showMessages", v-if="currentState", style="min-width: 70vw")
    Messages(
      :messages="(config || {}).messages",
      :sectionStartTime="currentState.startedAt",
      :sectionEndTime="currentState.endsAt",
      :editMessage="handleEditMessage",
      :sendMessage="handleSendMessage",
      :zoomSensors="zoomSensors",
      :createNewMessage="handleCreateNewMessage",
      :deleteMessage="handleDeleteMessage"
    )
  .row.q-pa-md.items-center
    q-btn.q-mr-sm(icon="message", flat, round, @click="showMessages = true")
      q-tooltip Messages
    q-btn(icon="people", flat, round, @click="showAssignmentVsActual = true")
      q-tooltip(v-if="!breakoutsCorrect") Breakout Rooms incorrect
      q-badge(v-if="!breakoutsCorrect", floating, rounded, dense, color="negative")
        q-icon(name="priority_high", size="small")
      q-badge(v-else-if="currentBreakoutRoomAssignment && Object.entries(currentBreakoutRoomAssignment).length", floating, rounded, dense, color="positive")
        q-icon(name="done", size="small")
      q-badge(v-if="currentBreakoutRooms.loading", floating, color="transparent")
        q-spinner(size="0.8rem", color="primary")
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import * as firebase from "firebase";
import {
  ZoomSenseConfigMeetingCurrentCurrentState,
  ZoomSenseCurrentUsersForMeeting,
  ZoomSenseDataLogsBOMetaMeeting,
  ZoomSenseMeetingChatNode
} from "@zoomsense/zoomsense-firebase";
import { ZoomSenseClientFirebaseDB } from "@zoomsense/zoomsense-firebase-client";
import { MessageConfig, RoomAssignment, TaskPluginConfiguration } from "zoomsense-plugin-task-shared";

import Topology from "./Topology.vue";
import Countdown from "./Countdown.vue";
import Messages from "./Messages.vue";
import BreakoutRooms from "./BreakoutRooms.vue";
import { breakoutsCorrect, CurrentBORooms, getCurrentBORooms } from "./currentBORooms";

export default Vue.extend({
  name: "Dashboard",
  data() {
    return {
      currentUsersForMeeting: null as null | ZoomSenseCurrentUsersForMeeting,
      currentState: null as null | ZoomSenseConfigMeetingCurrentCurrentState,
      currentBreakoutRoomAssignment: null as null | RoomAssignment,
      chats: null as null | { [displayName: string]: ZoomSenseMeetingChatNode },
      currentSection: null as null | number,
      boMeta: null as null | ZoomSenseDataLogsBOMetaMeeting,

      zoomSensors: [] as string[],
      showAssignmentVsActual: false,
      showMessages: false,
    };
  },
  computed: {
    config(): TaskPluginConfiguration | undefined {
      return this.currentState?.plugins?.task;
    },
    breakoutsCorrect(): boolean {
      return breakoutsCorrect(
        this.currentBreakoutRooms,
        this.config?.["breakout rooms"]?.assignment
      );
    },
    isInBO(): boolean {
      return this.currentBreakoutRooms["ZoomSensor_1"]?.isInBO ?? false;
    },
    currentBreakoutRooms(): CurrentBORooms {
      return getCurrentBORooms(this.currentUsersForMeeting ?? {}, this.boMeta);
    },
  },
  methods: {
    async handleEditMessage(editedMessage: MessageConfig, messageIndex: number) {
      const editMessage = this.functions.httpsCallable("Task-editMessage");
      await editMessage({
        editedMessage,
        messageIndex,
        meetingId: this.context.meetingid,
      });
    },
    async handleSendMessage(messageIndex: number) {
      const sendMessage = this.functions.httpsCallable("Task-sendMessage");
      await sendMessage({ messageIndex, meetingId: this.context.meetingid });
    },
    async handleCreateNewMessage(message: MessageConfig) {
      const newMessage = this.functions.httpsCallable("Task-newMessage");
      await newMessage({ message, meetingId: this.context.meetingid });
    },
    async handleRenameRoom(oldName: string, newName: string) {
      const renameRoom = this.functions.httpsCallable("Task-renameAssignment");
      await renameRoom({ oldName, newName, meetingId: this.context.meetingid });
    },
    async handleDeleteMessage(messageIndex: number) {
      const deleteMessage = this.functions.httpsCallable("Task-deleteMessage");
      await deleteMessage({ messageIndex, meetingId: this.context.meetingid });
    },
  },
  props: {
    firebase: {
      required: true,
      type: Object as PropType<ZoomSenseClientFirebaseDB>,
    },
    functions: {
      required: true,
      type: Object as PropType<firebase.functions.Functions>,
    },
    context: {
      required: false,
      type: Object as PropType<{meetingid: string, userId: string}>,
    },
  },
  async mounted() {
    await Promise.all([
      this.$typedRtdbBind(
        "currentState",
        this.firebase.ref(`config/${this.context.meetingid}/current/currentState`)
      ),
      this.$typedRtdbBind(
        "currentUsersForMeeting",
        this.firebase.ref(`data/currentUsers/${this.context.meetingid}`)
      ),
      this.$typedRtdbBind(
        "boMeta",
        this.firebase.ref(`data/logs/boMeta/${this.context.meetingid}`)
      ),
      this.$typedRtdbBind(
        "currentSection",
        this.firebase.ref(`config/${this.context.meetingid}/current/currentSection`)
      ),
      this.$typedRtdbBind(
        "chats",
        this.firebase.ref(`data/chats/${this.context.meetingid}`)
      ),
      this.$typedRtdbBind(
        "currentBreakoutRoomAssignment",
        this.firebase.ref(
          `config/${this.context.meetingid}/current/currentState/plugins/task/breakout rooms/assignment`
        )
      )
    ]);
  },
  watch: {
    chats: {
      immediate: true,
      handler(newVal) {
        this.zoomSensors = Object.keys(newVal || {});
      },
    },
  },
  components: {
    Countdown,
    Topology,
    BreakoutRooms,
    Messages,
  },
});
</script>
<style scoped>
.q-list--dense > div > .q-item {
  padding-left: 0.6rem;
}
</style>
